> ## Documentation Index
> Fetch the complete documentation index at: https://docs.open.cx/llms.txt
> Use this file to discover all available pages before exploring further.

> Directly send a WhatsApp template to a contact. Use when sending WhatsApp messages that require template approval or driving WhatsApp operations from automation.

# Send a WhatsApp template



## OpenAPI

````yaml post /whatsapp/send-template
openapi: 3.1.0
info:
  title: OpenCX API
  description: >

    OpenCX is an AI-powered, all-in-one platform for customer support and
    outbound communications.


    Use this API to manage your OpenCX organization's AI agents, actions,
    conversations, contacts, and more.


    To get started, generate a new API key from the dashboard.


    ## Authentication

    All API endpoints require authentication using a Bearer token. You can
    generate an API key from your OpenCX dashboard.


    ## Rate Limiting

    API requests are rate limited to ensure fair usage. The current limits are:

    - 100 requests per minute for standard endpoints

    - 1000 requests per minute for streaming endpoints


    ## Error Handling

    The API uses standard HTTP status codes and returns detailed error messages
    in the response body.
  version: 1.0-beta
  license:
    name: MIT
    url: https://opensource.org/licenses/MIT
servers:
  - url: https://api.open.cx
    description: Production
security:
  - bearerAuth: []
paths:
  /whatsapp/send-template:
    post:
      summary: Send a WhatsApp template
      description: Directly send a WhatsApp template to a contact
      operationId: sendTemplate
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/SendTemplateInputDto'
      responses:
        '200':
          description: Default Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/SendTemplateOutputDto'
        '500':
          description: Internal Server Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorDto'
components:
  schemas:
    SendTemplateInputDto:
      $schema: https://json-schema.org/draft/2020-12/schema
      $id: '#/components/schemas/SendTemplateInputDtoInput'
      type: object
      properties:
        template_id:
          type: string
        phone_number_id:
          type: string
        variables:
          type: array
          items:
            type: string
        contact:
          anyOf:
            - type: object
              properties:
                id:
                  type: string
                  format: uuid
                  pattern: >-
                    ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
              required:
                - id
            - type: object
              properties:
                email:
                  type: string
                  format: email
                  pattern: >-
                    ^(?!\.)(?!.*\.\.)([A-Za-z0-9_'+\-\.]*)[A-Za-z0-9_+-]@([A-Za-z0-9][A-Za-z0-9\-]*\.)+[A-Za-z]{2,}$
              required:
                - email
            - type: object
              properties:
                phone_number:
                  type: string
              required:
                - phone_number
        session_id:
          type: string
      required:
        - template_id
        - phone_number_id
        - variables
        - contact
    SendTemplateOutputDto:
      $schema: https://json-schema.org/draft/2020-12/schema
      $id: '#/components/schemas/SendTemplateOutputDto'
      type: object
      properties:
        whatsapp_message_id:
          type: string
        opencx_message_id:
          type: string
        opencx_session_id:
          type: string
      required:
        - whatsapp_message_id
        - opencx_message_id
        - opencx_session_id
      additionalProperties: false
    ErrorDto:
      type: object
      properties:
        statusCode:
          type: integer
        message:
          type: string
        error:
          type: string
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer
      bearerFormat: JWT

````